;;; $Id: all-ids.tst,v 1.3 2006/09/19 02:04:03 leavens Exp leavens $

(newline)
(displayln "Test case $RCSfile: all-ids.tst,v $ of $Date: 2006/09/19 02:04:03 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (set-equal? (all-ids (exp-stmt (var-exp 'x)))
		 (set 'x)) ==> #t )
   ( (set-equal? (all-ids (exp-stmt (var-exp 'y)))
		 (set 'y)) ==> #t )
   ( (set-equal? (all-ids (exp-stmt (num-exp 42)))
		 (set )) ==> #t )
   ( (set-equal? (all-ids (set-stmt 'y (var-exp 'x)))
		 (set 'y 'x)) ==> #t )
   ( (set-equal? (all-ids (set-stmt 'x (var-exp 'x)))
		 (set 'x)) ==> #t )
   ( (set-equal? (all-ids (set-stmt 'myvar (num-exp 3)))
		 (set 'myvar)) ==> #t )
   ( (set-equal? (all-ids (set-stmt 'myvar (num-exp 3)))
		 (set 'myvar)) ==> #t )
   ( (set-equal? (all-ids (exp-stmt (begin-exp '() (var-exp 'zz-top))))
		 (set 'zz-top)) ==> #t )
   ( (set-equal? (all-ids (parse-statement '(begin zz-top)))
		 (set 'zz-top)) ==> #t )
   ( (set-equal?
      (all-ids
       (parse-statement
	'(begin bart (set! marge 1) (set! homer zz-top) zz-top)))
      (set 'bart 'marge 'homer 'zz-top)) ==> #t )
   ( (set-equal?
      (all-ids
       (parse-statement
	'(begin (set! x0 (begin 3))
		(set! x1 (begin (set! x2 (begin 4)) x3))
		5 6 x4
		(begin x5)
		(begin (begin (begin b0) x6))
		(begin (set! b1 (begin x7)) b2))))
      (set 'x0 'x1 'x2 'x3 'x4 'x5 'b0 'x6 'b1 'x7 'b2)) ==> #t )
   ( (set-equal?
      (all-ids
       (parse-statement
	'(begin (set! x0 (begin (set! y0 (begin (set! z0 z1) y0))
				(set! z1 z2)
				3))
		(set! x1 (begin (set! x2 (begin 4)) x3))
		5 6 x4
		(begin (begin (set! qq foggy) x5))
		(begin (begin (begin (set! rm b0) x6)))
		(begin (set! b1 (begin x7)) b2))))
      (set 'x0 'x1 'x2 'x3 'x4 'x5 'b0 'x6 'b1 'x7 'b2
	   'qq 'foggy 'rm 'y0 'z0 'z1 'z2 'b2)) ==> #t )
   
   )
 )

(newline)
