;; $Id: free.tst,v 1.8 2006/09/26 09:56:15 leavens Exp leavens $

(newline)
(displayln "Test case $RCSfile: free.tst,v $ of $Date: 2006/09/26 09:56:15 $")
(newline)

(define lexp1 '(lambda (x) (f x)))
(define lexp2 `(lambda (z) (,lexp1 (g (h y)))))
(define lexp3 `(lambda (f) ,lexp2))
(define lexp4 `(,lexp3 (car (cdr (x (y (quote z)))))))
(define lexp5 `(lambda (y) ,lexp4))
(define lexp6 `(lambda (f) ,lexp4))
(define lexp7 `(,lexp5 ,lexp2))

(run-regression-tests-equal?
 `(
   ( (free? 'x (parse-expression 'x))      ==> #t )
   ( (free? 'x (parse-expression 'y))      ==> #f )
   ( (free? 'x (parse-expression '(x y)))  ==> #t )
   ( (free? 'g (parse-expression ',lexp1)) ==> #f )
   ( (free? 'f (parse-expression ',lexp2)) ==> #t )
   ( (free? 'f (parse-expression ',lexp3)) ==> #f )
   ( (free? 'x (parse-expression ',lexp4)) ==> #t )
   ( (free? 'z (parse-expression ',lexp5)) ==> #f )
   ( (free? 'y (parse-expression ',lexp6)) ==> #t )
   ( (free? 'y (parse-expression ',lexp7)) ==> #t )
   ))



