// $Id: BinaryTree.cpp,v 1.3 2006/10/10 12:37:30 leavens Exp leavens $

#include <iostream>
#include "BinaryTree.h"

bool Leaf::isLeaf() { return true; }
int Leaf::number() { return num; }
Leaf::Leaf(int n) { num = n; }
int Leaf::leafSum() { return num; }

bool Interior::isLeaf() { return false; }
BinaryTree* Interior::left_tree() { return left; }
BinaryTree* Interior::right_tree() { return right; }
char* Interior::symbol() { return sym; }
int Interior::leafSum() {
    return left_tree()->leafSum() + right_tree()->leafSum();
}

Interior::Interior(BinaryTree* l, char* s, BinaryTree* r) {
  left = l;
  sym = s;
  right = r;
}

int main() {

  using namespace std;

  BinaryTree *tree_a
    = new Interior(new Leaf(2), "a", new Leaf(3));
  cout << tree_a->leafSum() << endl;
  
  return(0);
}
